program diyo;

{$APPTYPE CONSOLE}

{$R *.dres}

{*
diyo Version 1.01
Editing MS932~EUC-JP.bin
Copyright 2018 Sogaya

Delphi
Free Pascal Compiler

*}

uses
  SysUtils,
  SparsePopulationEUC in 'SparsePopulationEUC.pas',
  Guide in 'Guide.pas',
  Editing in 'Editing.pas';

const
  ASCII = '-a';
  CIRCLED_ONE = '@'; { Shift_JIS }
  EMPTY = '';
  EUC_JP = '-e';
  HYPHEN = '-';
  KATAKANA = '-k';
  LIST_FILE = '-f';
  SHIFT_JIS = '-s';
  SJIS_EUC_BIN = 'MS932~EUC-JP.bin';
  UNDERLINE = 'Q';
  VERSION_COMMENTS = '-VC';
  VERSION_GUIDE = '-V';
  VERSION_NUMBER = '1.01';
  WHICH_TABLE = '-w';
  WITHOUT_COMMENTS = False;
  WITH_COMMENTS = True;

var
  binaryName: String;
  head: String;
  i: Integer;
  normal: AnsiString;
  s: String;
  size: Integer;
  sjis_text: String;
  substitute: AnsiString;
  to_be_read: Boolean;
  whichTable: Boolean;

begin
  binaryName := SJIS_EUC_BIN;
  normal := CIRCLED_ONE;
  sjis_text := EMPTY;
  substitute := UNDERLINE;
  to_be_read := False;
  whichTable := False;

  for i := 1 to ParamCount do
  begin
    s := ParamStr(i);
    head := Copy(s, 1, 1);
    if CompareStr(head, HYPHEN) = 0 then
      begin
        if CompareStr(s, LIST_FILE) = 0 then
          to_be_read := True;

        if CompareStr(s, VERSION_COMMENTS) = 0 then
          versionGuide(VERSION_NUMBER, WITH_COMMENTS);

        if CompareStr(s, VERSION_GUIDE) = 0 then
          versionGuide(VERSION_NUMBER, WITHOUT_COMMENTS);

        if CompareStr(s, WHICH_TABLE) = 0 then
          whichTable := True;

        head := Copy(s, 1, 2);
        if CompareStr(head, ASCII) = 0 then
          substitute := Copy(s, 3, 1);

        if CompareStr(head, EUC_JP) = 0 then
          substitute := Copy(s, 3, 2);

        if CompareStr(head, KATAKANA) = 0 then
          normal := Copy(s, 3, 1);

        if CompareStr(head, SHIFT_JIS) = 0 then
          normal := Copy(s, 3, 2);

      end
    else
      begin
        if to_be_read then
          begin
            sjis_text := s;
            to_be_read := False;
          end
        else
          begin
            binaryName := s;
          end;
      end;

  end; { for i := 1 to ParamCount do }

  size := Length(sjis_text);
  if size = 0 then
    editRecord(normal, substitute, binaryName, whichTable)
  else
    editManyRecords(sjis_text, binaryName, whichTable);

end.
