unit Accessible;

interface

uses
  SysUtils;

procedure ACE_should_disappear;
procedure binary_files_are_accessible_to_SideAce;

implementation

procedure ACE_should_disappear;
const
  ACE = 'ACE';
  ERROR_TEXT = 'error.txt';
var
  aceFile: TextFile;
  errorFile: TextFile;
  size: Integer;
begin
  if FileExists(ACE) then
    begin
      AssignFile(aceFile, ACE);
      Reset(aceFile);
      size := FileSize(aceFile);
      if size > 0 then
        begin
          AssignFile(errorFile, ERROR_TEXT);
          Rewrite(errorFile);

          WriteLn(errorFile, 'ACE should disappear. Please remove ACE from the current directory. ');
          CloseFile(errorFile);

          Halt(1);
        end;

      CloseFile(aceFile);
    end;

end;

procedure binary_files_are_accessible_to_SideAce;
const
  C_SJIS_EUC_BIN = 'C:\SideAceDelphi\MS932~EUC-JP.bin';
  C_SJIS_UTF8_BIN = 'C:\SideAceDelphi\MS932~UTF-8.bin';
  ERROR_TEXT = 'error.txt';
  SJIS_EUC_BIN = 'MS932~EUC-JP.bin';
  SJIS_UTF8_BIN = 'MS932~UTF-8.bin';
var
  errorFile: TextFile;
  n: Integer;
  found:  Boolean;
  perfect: Boolean;
  SJIS_EUC_TABLES: array[1..2] of String;
  SJIS_UTF8_TABLES: array[1..2] of String;
begin
  SJIS_EUC_TABLES[1] := C_SJIS_EUC_BIN;
  SJIS_EUC_TABLES[2] := SJIS_EUC_BIN;
  SJIS_UTF8_TABLES[1] := C_SJIS_UTF8_BIN;
  SJIS_UTF8_TABLES[2] := SJIS_UTF8_BIN;

  perfect := True;

  found := False;
  for n := 1 to 2 do
  begin
    if FileExists(SJIS_EUC_TABLES[n]) then
      found := True;

  end;

  if not found then
    perfect := False;

  found := False;
  for n := 1 to 2 do
  begin
    if FileExists(SJIS_UTF8_TABLES[n]) then
      found := True;

  end;

  if not found then
    perfect := False;

  if not perfect then
    begin
      AssignFile(errorFile, ERROR_TEXT);
      Rewrite(errorFile);

      Write(errorFile, SJIS_EUC_BIN);
      WriteLn(errorFile, ' is needed to convert ACE from Shift_JIS to EUC-JP. ');

      Write(errorFile, SJIS_UTF8_BIN);
      WriteLn(errorFile, ' is needed to convert ACE from Shift_JIS to UTF-8. ');
      CloseFile(errorFile);

      Halt(1);
    end;

end;

end.
